local time, scale, RADIUS, rotation = 0, 1, 200, 0
local scaleAround, rotateAround
local LG, W, H = love.graphics, love.graphics.getWidth(), love.graphics.getHeight()

local function normalScale(x, y, r, textOffset)
  LG.push()
  LG.scale(scale)
  LG.setColor(255, 0, 0, 200)
  LG.circle("line", x, y, r, 50)
  LG.print("normal", x, y + textOffset)
  LG.pop()
end

local function translateAndScale(x, y, r, textOffset)
  LG.push()
  LG.translate(x, y)
  LG.scale(scale)
  LG.setColor(0, 255, 0, 200)
  LG.circle("line", 0, 0, r, 50)
  LG.print("translate", 0, textOffset)
  LG.pop()
end

local function usingHelpers(x, y, r, textOffset)
  LG.push()
  scaleAround(x, y, scale)
  rotateAround(x, y, rotation)
  LG.setColor(0, 0, 255, 200)
  LG.circle("line", x, y, r, 50)
  LG.print("with helpers", x, y + textOffset)
  LG.pop()
end

function love.draw()
  LG.setLine(4)
  normalScale      (W/2, H/2, RADIUS-10, -15)
  translateAndScale(W/2, H/2, RADIUS   , 0)
  usingHelpers     (W/2, H/2, RADIUS+10, 15)
end

function love.update(dt)
  rotation = rotation + dt
  time = time + dt
  if time > 1 then time, scale = 0, 2.5 - scale end -- oscilates scale between 1 and 1.5.
end

--------------------------------------------------------------------------------

scaleAround = function(x, y, scale)
  if scale and scale ~= 1 then
    LG.translate(x, y)
    LG.scale(scale)
    LG.translate(-x, -y)
  end
end

rotateAround = function(x, y, angle)
  if angle and angle ~= 0 then
    LG.translate(x, y)
    LG.rotate(angle)
    LG.translate(-x, -y)
  end
end
